(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["StateEncodeRouter"] = factory();
	else
		root["StateEncodeRouter"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 4);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.encodeBase64 = encodeBase64;
exports.decodeBase64 = decodeBase64;
exports.parseJson = parseJson;
exports.notifyListeners = notifyListeners;
function encodeBase64(str) {
  return btoa(str).replace(/=/g, '~').replace(/\+/g, '-').replace(/\//g, '_');
}

function decodeBase64(str) {
  return atob(str.replace(/~/g, '=').replace(/-/g, '+').replace(/_/g, '/'));
}

function parseJson(str) {
  return str.trim().length > 0 ? JSON.parse(str) : '';
}

function notifyListeners(listeners, state) {
  for (var i in listeners) {
    listeners[i](state);
  }
}

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _utils = __webpack_require__(0);

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Helper functions
function verifyProtocol(obj) {
  var requiredMethods = ['start', 'stop', 'navigate'];

  for (var i in requiredMethods) {
    if (!obj[requiredMethods[i]]) {
      throw new Error('Method ' + requiredMethods[i] + ' not implemented');
    }
  }
}

// BaseRouter

var BaseRouter = function () {
  function BaseRouter() {
    _classCallCheck(this, BaseRouter);

    verifyProtocol(this);

    this._options = {
      serialize: JSON.stringify,
      compress: function compress(str) {
        return str;
      },
      encode: _utils.encodeBase64,
      decode: _utils.decodeBase64,
      decompress: function decompress(str) {
        return str;
      },
      deserialize: _utils.parseJson
    };

    for (var _len = arguments.length, presetsOrOptions = Array(_len), _key = 0; _key < _len; _key++) {
      presetsOrOptions[_key] = arguments[_key];
    }

    for (var i in presetsOrOptions) {
      this._options = _extends({}, this._options, presetsOrOptions[i]);
    }

    this._currentState = {};
    this._running = false;
    this._navigationListeners = [];
  }

  _createClass(BaseRouter, [{
    key: 'encodeState',
    value: function encodeState() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (JSON.stringify(state) === '{}') {
        return '';
      } else {
        return this._options.encode(this._options.compress(this._options.serialize(state)));
      }
    }
  }, {
    key: 'decodeState',
    value: function decodeState() {
      var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      if (typeof str !== 'string' || str.length === 0) {
        return {};
      } else {
        return this._options.deserialize(this._options.decompress(this._options.decode(str)));
      }
    }
  }, {
    key: 'isRunning',
    value: function isRunning() {
      return this._running;
    }
  }, {
    key: 'getCurrentState',
    value: function getCurrentState() {
      return this._currentState;
    }
  }, {
    key: 'addNavigationListener',
    value: function addNavigationListener(callback) {
      this._navigationListeners.push(callback);
      return this;
    }
  }, {
    key: 'removeNavigationListener',
    value: function removeNavigationListener(callback) {
      var index = this._navigationListeners.indexOf(callback);

      if (index >= 0) {
        this._navigationListeners.splice(callback, 1);
      }
    }
  }]);

  return BaseRouter;
}();

exports.default = BaseRouter;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _baseRouter = __webpack_require__(1);

var _baseRouter2 = _interopRequireDefault(_baseRouter);

var _utils = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Private methods
function onStateChange() {
  var state = this.parseHash(window.location.hash);

  if (JSON.stringify(state) !== JSON.stringify(this._currentState)) {
    this._currentState = state;
    (0, _utils.notifyListeners)(this._navigationListeners, state);
  }
}

var HashRouter = function (_BaseRouter) {
  _inherits(HashRouter, _BaseRouter);

  function HashRouter() {
    var _ref;

    _classCallCheck(this, HashRouter);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _possibleConstructorReturn(this, (_ref = HashRouter.__proto__ || Object.getPrototypeOf(HashRouter)).call.apply(_ref, [this].concat(args)));
  }

  _createClass(HashRouter, [{
    key: 'start',
    value: function start() {
      if (!this._running) {
        this._running = true;
        window.addEventListener('popstate', onStateChange.bind(this));
        window.addEventListener('hashchange', onStateChange.bind(this));

        onStateChange.call(this);
      }

      return this;
    }
  }, {
    key: 'stop',
    value: function stop() {
      if (this._running) {
        window.removeEventListener('popstate', onStateChange.bind(this));
        window.removeEventListener('hashchange', onStateChange.bind(this));
        this._running = false;
      }
    }
  }, {
    key: 'formatHash',
    value: function formatHash(state) {
      return '#' + this.encodeState(state);
    }
  }, {
    key: 'parseHash',
    value: function parseHash() {
      var hash = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '#';

      if (typeof hash !== 'string' || hash === '' || hash === '#') {
        return {};
      }

      var encodedState = /^#?(.*)$/.exec(hash)[1];

      return encodedState ? this.decodeState(encodedState) : '';
    }
  }, {
    key: 'navigate',
    value: function navigate(state) {
      window.location.hash = this.formatHash(state);
    }
  }]);

  return HashRouter;
}(_baseRouter2.default);

exports.default = HashRouter;

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _baseRouter = __webpack_require__(1);

var _baseRouter2 = _interopRequireDefault(_baseRouter);

var _utils = __webpack_require__(0);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PathRouter = function (_BaseRouter) {
  _inherits(PathRouter, _BaseRouter);

  function PathRouter() {
    _classCallCheck(this, PathRouter);

    return _possibleConstructorReturn(this, (PathRouter.__proto__ || Object.getPrototypeOf(PathRouter)).apply(this, arguments));
  }

  return PathRouter;
}(_baseRouter2.default);

exports.default = PathRouter;
;

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Utils = exports.PathRouter = exports.HashRouter = exports.BaseRouter = undefined;

var _baseRouter = __webpack_require__(1);

Object.defineProperty(exports, 'BaseRouter', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_baseRouter).default;
  }
});

var _hashRouter = __webpack_require__(2);

Object.defineProperty(exports, 'HashRouter', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_hashRouter).default;
  }
});

var _pathRouter = __webpack_require__(3);

Object.defineProperty(exports, 'PathRouter', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_pathRouter).default;
  }
});

var _utils = __webpack_require__(0);

var Utils = _interopRequireWildcard(_utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.Utils = Utils;

/***/ })
/******/ ]);
});